<?php 
/**
 * Calcula distancias - calculadistancias.php
 * 
 * @author    Bartolomé Sintes Marco <bartolome.sintes+mclibre@gmail.com>
 * @copyright 2009 Bartolomé Sintes Marco
 * @license   http://www.gnu.org/licenses/agpl.txt AGPL 3 or later
 * @version   2009-05-27
 * @link      http://www.mclibre.org
 *
 *  This program is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Affero General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Affero General Public License for more details.
 *
 *  You should have received a copy of the GNU Affero General Public License
 *  along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

print "<?xml version=\"1.0\" encoding=\"iso-8859-1\"?".">\n"; 
?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN"
       "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
  <meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1" />
  <title>Calcula distancias (Resultado).
  Exámenes. PHP. Bartolomé Sintes Marco</title>
  <link href="mclibre_php_soluciones.css" rel="stylesheet" type="text/css" 
  title="Color" />
</head>

<body>
<h1>Calcula distancias (Resultado)</h1>
<?php
function recoge($var)
{ 
    $tmp = (isset($_REQUEST[$var])) ? trim(strip_tags($_REQUEST[$var])) : '';
    if (get_magic_quotes_gpc()) {
       $tmp = stripslashes($tmp);
    }
    $tmp = str_replace('&', '&amp;',  $tmp);
    $tmp = str_replace('"', '&quot;', $tmp);
    return $tmp;
}

define('RADIO_TIERRA', 6378);
define('PI',           3.141592);

$longitud1 = recoge('longitud1');
$ns1       = recoge('ns1');
$latitud1  = recoge('latitud1');
$eo1       = recoge('eo1');
$longitud2 = recoge('longitud2');
$ns2       = recoge('ns2');
$latitud2  = recoge('latitud2');
$eo2       = recoge('eo2');
$longitud1Ok = $ns1Ok = $latitud1Ok = $eo1Ok = FALSE;
$longitud2Ok = $ns2Ok = $latitud2Ok = $eo2Ok = FALSE;

if ($longitud1=="") {
    print "<p style=\"color: red\">No ha escrito la longitud del punto 1.</p>\n";
} elseif (!is_numeric($longitud1)) { 
    print "<p style=\"color: red\">No ha escrito la longitud del punto 1 como número.</p>\n";
} elseif ($longitud1<0) {
    print "<p style=\"color: red\">La longitud del punto 1 no puede ser negativa.</p>\n";
} elseif ($longitud1>180) {
    print "<p style=\"color: red\">La longitud del punto 1 no puede ser mayor de 180º.</p>\n";
} else {
    $longitud1Ok = TRUE;
}

if ($latitud1=="") {
    print "<p style=\"color: red\">No ha escrito la latitud del punto 1.</p>\n";
} elseif (!is_numeric($latitud1)) { 
    print "<p style=\"color: red\">No ha escrito la latitud del punto 1 como número.</p>\n";
} elseif ($latitud1<0) {
    print "<p style=\"color: red\">La latitud del punto 1 no puede ser negativa.</p>\n";
} elseif ($latitud1>90) {
    print "<p style=\"color: red\">La latitud del punto 1 no puede ser mayor de 90º.</p>\n";
} else {
    $latitud1Ok = TRUE;
}

if ($longitud2=="") {
    print "<p style=\"color: red\">No ha escrito la longitud del punto 2.</p>\n";
} elseif (!is_numeric($longitud2)) { 
    print "<p style=\"color: red\">No ha escrito la longitud del punto 2 como número.</p>\n";
} elseif ($longitud2<0) {
    print "<p style=\"color: red\">La longitud del punto 2 no puede ser negativa.</p>\n";
} elseif ($longitud2>180) {
    print "<p style=\"color: red\">La longitud del punto 2 no puede ser mayor de 180º.</p>\n";
} else {
    $longitud2Ok = TRUE;
}

if ($latitud2=="") {
    print "<p style=\"color: red\">No ha escrito la latitud del punto 2.</p>\n";
} elseif (!is_numeric($latitud2)) { 
    print "<p style=\"color: red\">No ha escrito la latitud del punto 2 como número.</p>\n";
} elseif ($latitud2<0) {
    print "<p style=\"color: red\">La latitud del punto 2 no puede ser negativa.</p>\n";
} elseif ($latitud2>90) {
    print "<p style=\"color: red\">La latitud del punto 2 no puede ser mayor de 90º.</p>\n";
} else {
    $latitud2Ok = TRUE;
}

if (($ns1!='N')&&($ns1!='S')) {
    print "<p style=\"color: red\">Error en la latitud del punto 1.</p>\n";
} else {
    $ns1Ok = TRUE;
}

if (($eo1!='E')&&($eo1!='O')) {
    print "<p style=\"color: red\">Error en la longitud del punto 1.</p>\n";
} else {
    $eo1Ok = TRUE;
}

if (($ns2!='N')&&($ns2!='S')) {
    print "<p style=\"color: red\">Error en la latitud del punto 2.</p>\n";
} else {
    $ns2Ok = TRUE;
}
    
if (($eo2!='E')&&($eo2!='O')) {
    print "<p style=\"color: red\">Error en la longitud del punto 2.</p>\n";
} else {
    $eo2Ok = TRUE;
}

if ($longitud1Ok && $ns1Ok && $latitud1Ok && $eo1 &&
    $longitud2Ok && $ns2Ok && $latitud2Ok && $eo2) {
    $longitud1b = $longitud1*PI/180;
    $latitud1b  = $latitud1*PI/180;
    $longitud2b = $longitud2*PI/180;
    $latitud2b  = $latitud2*PI/180;
    if ($ns1=='S') {
        $latitud1b = -$latitud1b;
    }
    if ($ns2=='S') {
        $latitud2b = -$latitud2b;
    }
    if ($eo1=='E') {
        $longitud1b = -$longitud1b;
    }
    if ($eo2=='E') {
        $longitud2b = -$longitud2b;
    }
    $result = round(acos(sin($latitud1b)*sin($latitud2b)+cos($latitud1b)*
        cos($latitud2b)*cos($longitud2b-$longitud1b))*RADIO_TIERRA);
    print "<p>La distancia entre los puntos $latitud1$ns1 $longitud1$eo1 y ".
        "$latitud2$ns2 $longitud2$eo2 es de $result km.</p>\n";
    print "<p>Gracias por utilizar esta calculadora de distancias.</p>\n";
}

print "<p><a href=\"distanciasglobo_1.html\">Volver al formulario.</a></p>\n";
?>

<address>
  Esta página forma parte del curso "Páginas web con PHP" disponible en <a
  href="http://www.mclibre.org/">http://www.mclibre.org</a><br />
  Autor: Bartolomé Sintes Marco<br />
  Última modificación de esta página: 27 de mayo de 2009
</address>
<p class="licencia">El programa PHP que genera esta página está bajo 
<a rel="license" href="http://www.gnu.org/licenses/agpl.txt">licencia AGPL 3 o
posterior</a>.</p>
</body>
</html>
